/* File    - menu_struct.c
 * Author  - Jared Eby
 * Date    - 1/10/2016
 * Purpose - Contains sub-item routines as well as all custom menu declarations.
 */
#include <stdio.h>
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "menu_struct.h"




/*Menu declarations
 */
extern struct menu main_menu;
extern struct menu sub_menu_01;
extern struct menu sub_menu_02;
extern struct menu sub_menu_03;
extern struct menu sub_menu_03_1;
extern struct menu sub_menu_03_2;
extern struct menu sub_menu_03_3;
void (*fptr)(void) = &test_func2;							//POINTER FOR TESTING ONLY



/*Sub-item routines
 */
void sub_item_01_1 ( void ) {UART_CPutString((const char*)"\tItem one-one (1.1)\n");}
void sub_item_01_2 ( void ) {UART_CPutString((const char*)"\tItem one-two (1.2)\n");}
void sub_item_01_3 ( void ) {UART_CPutString((const char*)"\tItem one-three (1.3)\n");}
void sub_item_02_1 ( void ) {UART_CPutString((const char*)"\tItem two-one (2.1)\n");}
void sub_item_02_2 ( void ) {UART_CPutString((const char*)"\tItem two-two (2.2)\n");}
void sub_item_02_3 ( void ) {UART_CPutString((const char*)"\tItem two-three (2.3)\n");}
void sub_item_03_1_1 ( void ) {UART_CPutString((const char*)"\tItem three-one-one (3.1.1)\n");}
void sub_item_03_1_2 ( void ) {UART_CPutString((const char*)"\tItem three-one-two (3.1.2)\n");}
void sub_item_03_2_1 ( void ) {UART_CPutString((const char*)"\tItem three-one-one (3.1.1)\n");}
void sub_item_03_2_2 ( void ) {UART_CPutString((const char*)"\tItem three-one-two (3.1.2)\n");}
void sub_item_03_3_1 ( void ) {UART_CPutString((const char*)"\tItem three-one-one (3.1.1)\n");}
void sub_item_03_3_2 ( void ) {UART_CPutString((const char*)"\tItem three-one-two (3.1.2)\n");}

void test_func2 ( void ) {UART_CPutString((const char*)"\tfunction pointer successful!!!!!!\n");}		//FUNCTIONS FOR TESTING FUNCTION POINTERS
void test_func1 ( void ) {
	(*fptr)();
	((void(*)(void*))(sub_menu_01.menulist[0].item))();													//THE COMPILER THROWS AN ERROR HERE
}





/*Menu list declarations and initialization
 */
struct menulist main_list[] = {	
	{ '1', (char*)"Set Alarm",'M', &sub_menu_01 },
	{ '2', (char*)"Set Date/Time",'M', &sub_menu_02 },
	{ '3', (char*)"Testing Options",'M', &sub_menu_03 }
};

struct menulist sub_list01[] = {	
	{ '1', (char*)"Item one", 'F', (void*)sub_item_01_1 },
	{ '2', (char*)"Item two", 'F', (void*)sub_item_01_2 },
	{ '3', (char*)"Item three", 'F', (void*)sub_item_01_3 }
};

struct menulist sub_list02[] = {	
	{ '1', (char*)"Item one", 'F', (void*)sub_item_02_1 },
	{ '2', (char*)"Item two", 'F', (void*)sub_item_02_2 },
	{ '3', (char*)"Item three", 'F', (void*)sub_item_02_3 }
};

struct menulist sub_list03[] = {	
	{ '1', (char*)"Nixie Tubes", 'M', &sub_menu_03_1 },
	{ '2', (char*)"RGB LEDs", 'M', &sub_menu_03_2 },
	{ '3', (char*)"Buzzer", 'M', &sub_menu_03_3}
};

struct menulist sub_list03_1[] = {	
	{ '1', (char*)"Item one", 'F', (void*)sub_item_03_1_1 },
	{ '2', (char*)"Item two", 'F', (void*)sub_item_03_1_2 }
};

struct menulist sub_list03_2[] = {	
	{ '1', (char*)"Item one", 'F', (void*)sub_item_03_2_1 },
	{ '2', (char*)"Item two", 'F', (void*)sub_item_03_2_2 }
};

struct menulist sub_list03_3[] = {	
	{ '1', (char*)"Item one", 'F', (void*)sub_item_03_3_1 },
	{ '2', (char*)"Item two", 'F', (void*)sub_item_03_3_2 }
};


/*Menu initialization
 */
struct menu main_menu = {
	(char*)"Main Menu v0.1",
	main_list,
	MENUSIZE(main_list),
	&main_menu,
	&main_menu
};

struct menu sub_menu_01 = {
	(char*)"Alarm Menu",
	sub_list01,
	MENUSIZE(sub_list01),
	&main_menu,
	&main_menu
};

struct menu sub_menu_02 = {
	(char*)"Date/Time Menu",
	sub_list02,
	MENUSIZE(sub_list02),
	&main_menu,
	&main_menu
};

struct menu sub_menu_03 = {
	(char*)"Testing Menu",
	sub_list03,
	MENUSIZE(sub_list03),
	&main_menu,
	&main_menu
};

struct menu sub_menu_03_1 = {
	(char*)"Nixie Tubes Menu",
	sub_list03_1,
	MENUSIZE(sub_list03_1),
	&sub_menu_03,
	&main_menu
};

struct menu sub_menu_03_2 = {
	(char*)"RGB LEDs Menu",
	sub_list03_2,
	MENUSIZE(sub_list03_2),
	&sub_menu_03,
	&main_menu
};

struct menu sub_menu_03_3 = {
	(char*)"Buzzer Menu",
	sub_list03_3,
	MENUSIZE(sub_list03_3),
	&sub_menu_03,
	&main_menu
};


/*Creates a pointer that defaults to the main menu.  The menu can be
 *traversed by updating this pointer to the new position in the menu.
 */
struct menu *current_menu = &main_menu;


