/* File    - menu_struct.h
 * Author  - Jared Eby
 * Date    - 11/2/2009
 * Purpose - Definitions for structures and function prototypes
 *           in menu_struct.c
 */
#ifndef MENU_STRUCT_H_
#define MENU_STRUCT_H_


#define MENUSIZE(menu) sizeof(menu)/sizeof(struct menulist)

struct menulist {
	char		id;
	char	*	text;
	char		itemtype;	// M=menu	F=function
	void	*	item;		// menu or function
};

struct menu {
	char			*	heading;
	struct menulist	*	menulist;
	int					menusize;
	struct menu		*	prevmenu;
	struct menu		*	topmenu;
};

extern void (*fptr)(void);
extern struct menu *current_menu;

void sub_item_01_1 ( void );
void sub_item_01_2 ( void );
void sub_item_01_3 ( void );
void sub_item_02_1 ( void );
void sub_item_02_2 ( void );
void sub_item_02_3 ( void );
void sub_item_03_1_1 ( void );
void sub_item_03_1_2 ( void );
void sub_item_03_2_1 ( void );
void sub_item_03_2_2 ( void );
void sub_item_03_3_1 ( void );
void sub_item_03_3_2 ( void );
void test_func2 ( void );
void test_func1 ( void );


#endif

